Installer - Bug #8389

foreman-installer does not start foreman-proxy with mixed-case hostnames
11/13/2014 03:46 AM - Fabien Combernous

Status: Closed
Priority: Normal
Assignee: Ewoud Kohl van Wijngaarden
Category: Foreman modules
Target version: 1.11.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases: 1.6.1
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/puppet-for
eman_proxy/pull/148

Description
| used rpms from the foreman repo : foreman-installer-1.6.2-1.el6.

My hostname is named uppercase like MYHOSTNAME.mydomain.

The foreman-installer failed with the following message :

Could not start Service[foreman-proxy]: Execution of '/sbin/service foreman-proxy start' returned

1: Starting foreman-proxy : [FAILED]

/Stage[main] /Foreman_proxy: :Service/Service[foreman-proxy]/ensure: change from stopped to running

failed: Could not start Service[foreman-proxy]: Execution of '/sbin/service foreman-proxy start' r
eturned 1: Starting foreman-proxy : [FAILED]

/Stage[main] /Foreman_proxy: :Register/Foreman_smartproxy [MYHOSTNAME .mydomain]: Failed to call refre
sh: Could not load data from https://MYHOSTNAME.mydomain

/Stage[main] /Foreman_proxy: :Register/Foreman_smartproxy [MYHOSTNAME .mydomain]: Could not load data

from https://MYHOSTNAME.mydomain

Installing Done [L1008 ] [ttt titim it it e e ettt e e eeeeeeeeseeeeenenaneeenens ]

Something went wrong! Check the log for ERROR-level output

It was on a VM. So i did a rollback with snapshot, renamed the host in lowercase. Then re-run the installer. This time it finished
without any error message.

Related issues:

Related to Installer - Bug #6352: Default install fails when hostname contain... Closed

Associated revisions

Revision 8d35606a - 11/19/2015 09:27 AM - Ewoud Kohl van Wijngaarden

Fixes #8389 - Force certificate names to lowercase

Puppet will always create the certificate filenames as lowercase, even
if your hostname has uppercase characters in it.

Revision 54f60e5e - 11/23/2015 05:44 AM - Dominic Cleal

refs #8389 - lower case Foreman hostname to match foreman_proxy

Lower case FQDN used in the Foreman URL for apipie-bindings (in Hammer)
to work correctly and also to match foreman_proxy to ensure correct

ordering of foreman_smartproxy resources in init.pp's resource
collector.

Revision 761dc5f0 - 11/23/2015 05:46 AM - Dominic Cleal

refs #8389 - lower case FQDN in foreman_url parameter

Ensures that the HTTP requests from ENC/report processors work
correctly and don't receive a 404.

History

#1 - 11/13/2014 03:47 AM - Fabien Combernous

- Related to Bug #6352: Default install fails when hostname contains uppercase characters added

#2 - 11/13/2014 03:51 AM - Dominic Cleal
Do you have any logs from the smart proxy showing why it didn't start? | can't think of a reason off the top of my head why the hostname would
prevent the startup, unless perhaps the cert filenames were incorrect in /etc/foreman-proxy/settings.yml.

#3 - 11/13/2014 04:51 AM - Fabien Combernous

- File foreman-installer.log added
As attached document, the full log indicated by the foreman-installer.
#4 - 11/13/2014 05:02 AM - Dominic Cleal

Yeah, that doesn't show the proxy logs. My only suspicion is the SSL certificate names...

[ INFO 2014-11-13 10:41:19 main] +:ssl_certificate: /var/lib/puppet/ssl/certssMYHOSTNAME.mydomain.pem
[ INFO 2014-11-13 10:41:19 main] +:ssl_private_key: /var/lib/puppet/ssl/private_keys/MYHOSTNAME.mydomain.pem

#5 - 11/13/2014 05:08 AM - Fabien Combernous

Files are presents but lowercase

#6 - 11/13/2014 05:11 AM - Dominic Cleal
- Project changed from Smart Proxy to Installer

- Category set to Foreman modules
#7 - 11/18/2014 05:40 PM - Tommy McNeely
Just had this happen here too...

[root@DevForeman foreman-proxyl# tail -50 proxy.log
# Logfile created on Tue Nov 18 15:29:27 -0700 2014 by logger.rb/1.2.6

E, [2014-11-18T15:29:28.452345 #3779] ERROR -—- : Unable to access the SSL keys. Are the values correct in sett
ings.yml and do permissions allow reading?: No such file or directory - /var/lib/puppet/ssl/private_keys/DevFo
reman.dev.pem

E, [2014-11-18T15:29:28.452426 #3779] ERROR -—- : Both http and https are disabled, unable to start.

E, [2014-11-18T15:30:35.812443 #4117] ERROR -- : Unable to access the SSL keys. Are the values correct in sett
ings.yml and do permissions allow reading?: No such file or directory - /var/lib/puppet/ssl/private_keys/DevFo
reman.dev.pem

E, [2014-11-18T15:30:35.812551 #4117] ERROR -- : Both http and https are disabled, unable to start.
[root@DevForeman foreman-proxyl# ls -1 /var/lib/puppet/ssl/

ca/ certs/ private/ public_keys/

certificate_requests/ crl.pem private_keys/

[root@DevForeman foreman-proxyl# ls -1 /var/lib/puppet/ssl/private_keys/

total 4

—rw-r————-— . 1 puppet puppet 3247 Nov 18 15:29 devforeman.dev.pem

#8 - 02/08/2015 01:31 AM - Matt Altieri

| was able to get a broken install going [due to uppercase letters in hostname] by first changing the hostname to all lowercase & re-running the
installer (which at least generated new puppet certs - | can't say for sure how much else it did succeed at repairing ... but | can say what it didn't).

Orig Error - | suspect the failure to get settings was due to IPtables, as well:

[root@Foreman ~]# foreman—-installer

/Stage[main] /Foreman_proxy::Service/Service[foreman—-proxy]/ensure: change from stopped to running failed: Cou
1d not start Service[foreman-proxy]: Execution of '/sbin/service foreman-proxy start' returned 1: at /usr/sha
re/foreman-installer/modules/foreman_proxy/manifests/service.pp:9

/Stage [main] /Foreman_proxy::Register/Foreman_smartproxy[Foreman.McUnimportant]: Failed to call refresh: Could
not load data from https://Foreman.McUnimportant

Installing Done [100%] [eveeetmeeeeeeeeeeeeaeeenens

Something went wrong! Check the log for ERROR-level output

* Foreman is running at https://Foreman.McUnimportant
Initial credentials are admin / redacted
* Foreman Proxy 1is running at https://Foreman.McUnimportant:8443
* Puppetmaster is running at port 8140
The full log is at /var/log/foreman-installer/foreman-installer.log

However, the re-run didn't fix the uppercase hostname in the apache config files

[root@Foreman conf.d]# grep McUnimportant ./*

./05-foreman.conf: ServerName Foreman.McUnimportant
./05-foreman.conf:PassengerPreStart http://Foreman.McUnimportant
./05-foreman-ssl.conf: ServerName Foreman.McUnimportant
./05-foreman-ssl.conf:PassengerPreStart https://Foreman.McUnimportant

...edited these, and still no luck.

Because the settings in /usr/share/foreman-proxy/config/settings.yml were still pointed at the uppercase, original certificate name -- which no longer
existed.

Edited these three lines to point at the proper cert name:

:ssl_ca_file: /var/lib/puppet/ssl/certs/ca.pem
:ssl_certificate: /var/lib/puppet/ssl/certs/foreman.mcunimportant.pem
:ssl_private_key: /var/lib/puppet/ssl/private_keys/foreman.mcunimportant.pem

And Voila:

[root@foreman cal# service foreman-proxy start
Starting foreman-proxy: [ OK 1]

...hope this is helpful.

#9 - 02/09/2015 12:21 PM - Ewoud Kohl van Wijngaarden

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/puppet-foreman_proxy/pull/148 added
- Pull request deleted ()

Untested code, but it should work since | copied it from puppet-foreman which already does a similar thing.

#10 - 11/20/2015 06:30 AM - Dominic Cleal

- Subject changed from foreman-installer does not start foreman-proxy to foreman-installer does not start foreman-proxy with mixed-case hostnames
- Status changed from Ready For Testing to Closed

- Assignee set to Ewoud Kohl van Wijngaarden

- % Done changed from 0 to 100

- translation missing: en.field_release set to 104

#11 - 01/19/2016 03:11 AM - Dominic Cleal

- translation missing: en.field_release changed from 104 to 71

Non-trivial due to a few module updates.
